%define name	gpac
%define version	0.5.0
%define rel	4
%define release %mkrel %{rel}
%define osmo	Osmo4

# disable format string check, can't fix it for WxWidgets part
%define Werror_cflags %{nil}

Name: 	 	%{name}
Summary: 	MPEG-4 multimedia framework
Version: 	%{version}
Release: 	%{release}

Source:		http://downloads.sourceforge.net/gpac/%{name}-%{version}.tar.xz

Patch0:		110_all_implicitdecls.patch
Patch1:		210_all_system_libogg.patch
Patch2:		gpac-0.5.0-build-fixes.patch
Patch3:		gpac-0.5.0-libav9.patch
Patch4:		gpac-0.5.0-ffmpeg2.patch
Patch5:		gpac-0.5.0-mp42ts.patch
Patch6:		gpac-0.5.0-respect_ldflags.patch
Patch7:		gpac-link.patch
Patch8:		gpac-0.5.0-ffpeg-2.4.patch
License:	LGPL
Group:		Video
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	ImageMagick
BuildRequires:	SDL-devel
BuildRequires:	mesaglu-devel
BuildRequires:	freeglut-devel
BuildRequires:	freetype2-devel
BuildRequires:	libfaad2-devel
BuildRequires:	jpeg-devel
BuildRequires:	png-devel
BuildRequires:	libmad-devel
BuildRequires:	xvid-devel
BuildRequires:	ffmpeg-devel
BuildRequires:	libxml2-devel
BuildRequires:	openssl-devel
BuildRequires:	zlib-devel
BuildRequires:	libogg-devel
BuildRequires:	libvorbis-devel
BuildRequires:	libtheora-devel
BuildRequires:	wxGTK-devel
BuildRequires:	wxgtku-devel
BuildRequires:	libalsa-devel
BuildRequires:	pulseaudio-devel
BuildRequires:	libxv-devel
BuildConflicts: %{_lib}directfb-devel
Obsoletes:	Osmo4 < %version
Requires: glibc >= 2.20

%description
GPAC is a multimedia framework based on the MPEG-4 Systems standard developed
from scratch in ANSI C.  The original development goal is to provide a clean
(a.k.a. readable by as many people as possible), small and flexible
alternative to the MPEG-4 Systems reference software.

The natural evolution has been the integration of recent multimedia standards
(SVG/SMIL, VRML, X3D, SWF, 3GPP(2) tools, etc) into a single framework.
VRML97 and a good amount of the X3D standard have already been integrated
into GPAC, as well as some SVG support and experimental Macromedia Flash
support.

The current GPAC release (0.4.0) already covers a very large part of the
MPEG-4 standard, and has some good support for 3GPP and VRML/X3D, and
features what can probably be seen as the most advanced and robust 2D MPEG-4
Player available worldwide, as well as a decent 3D player.

GPAC also features MPEG-4 Systems encoders/multiplexers, publishing tools for
content distribution for MP4 and 3GPP(2) files and many tools for scene
descriptions (MPEG4<->VRML<->X3D converters, SWF->MPEG-4, etc...).


%package	devel
Summary:	Static library from gpac
Group:		Development/Libraries

%description	devel
Static library from gpac.

%package -n	%osmo
Summary:	Media player based on gpac
Group:		Video

%description -n %osmo
Osmo4 is an MPEG-4 player with the following features:
  * MPEG-4 Systems player:
  * Optimized 2D graphics renderer compliant with the Complete2D Scene Graph
    and Graphics profiles.
  * Video and audio presentation achieved through plugins
  * Multimedia player features:
    * Timeline controls: play, pause, step.
    * Graphics features: antialising, zoom and pan, scalable resizing of
      rendering area, basic full screen support.
    * Support for Advanced Text and Graphics extension of MPEG-4 Systems
      under standardization.
    * Frame export to JPG, PNG, BMP.

Osmo4 enables the use of MPEG-4 Systems in a vast aplication domain, among
which:
  * downloaded or streamed cartoons
  * synchronized, interactive mixes of graphics, text, video and audio
  * applications benefiting from MPEG-7 and MPEG-21 advances: meta-data,
    encryption, watermarking, rights management


%prep
%setup -q -n gpac
%apply_patches

chmod 755 configure

# SHH!
sed -i -e 's/Wall/w/g' `find -name Makefile`
# remove last of internal ogg
sed -i -e 's:<gpac/internal/ogg.h>:<ogg/ogg.h>:' \
	src/media_tools/{av_parsers,gpac_ogg,media_import,media_export}.c
rm -f include/gpac/internal/ogg.h

%build
%configure2_5x \
		--libdir=%{_lib} \
		--enable-static-lib \
		--use-js=no \
		--use-ffmpeg=system \
		--extra-cflags="%{optflags}"

%make
		
%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std install-lib


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc AUTHORS BUGS Changelog COPYING README TODO
%{_bindir}/MP4Box
%{_bindir}/MP4Client
%{_bindir}/mp42ts
%{_libdir}/%name
%{_libdir}/libgpac.so.*
%{_mandir}/man1/*
%{_datadir}/%{name}

%files 	devel
%defattr(-,root,root)
%{_includedir}/%name
%{_libdir}/libgpac.so
%{_libdir}/libgpac_static.a

%changelog
* Fri Feb 18 2015 bb <bb> 0.5.0-4pclos2015
- rebuild new glibc

* Mon Nov 16 2014 bb <bb> 0.5.0-3pclos2014
- rebuild ffmpeg 2.4.3

* Wed Aug 20 2014 bb <bb> 0.5.0-2pclos2014
- rebuild for new directfb
